/**
 * @file
 * VuoList_VuoAudioSamples C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoAudioSamples_H
#define VuoList_VuoAudioSamples_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoAudioSamples VuoList_VuoAudioSamples
 * A list of @ref VuoAudioSamples elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoAudioSamples_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoAudioSamples elements.
 */
typedef void * VuoList_VuoAudioSamples;
/// @}
#endif

/**
 * Creates a new list of @ref VuoAudioSamples elements.
 */
VuoList_VuoAudioSamples VuoListCreate_VuoAudioSamples(void);

/**
 * Returns the @ref VuoAudioSamples at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoAudioSamples VuoListGetValueAtIndex_VuoAudioSamples(const VuoList_VuoAudioSamples list, const unsigned long index);

/**
 * Changes the @ref VuoAudioSamples at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValueAtIndex_VuoAudioSamples(const VuoList_VuoAudioSamples list, const VuoAudioSamples value, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoAudioSamples(VuoList_VuoAudioSamples list, const VuoAudioSamples value);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoAudioSamples(VuoList_VuoAudioSamples list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoAudioSamples(VuoList_VuoAudioSamples list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoAudioSamples(VuoList_VuoAudioSamples list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoAudioSamples(const VuoList_VuoAudioSamples list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoAudioSamples VuoList_VuoAudioSamples_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoAudioSamples_jsonFromValue(const VuoList_VuoAudioSamples value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoAudioSamples_summaryFromValue(const VuoList_VuoAudioSamples value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoAudioSamples VuoList_VuoAudioSamples_valueFromString(const char *str);
char * VuoList_VuoAudioSamples_stringFromValue(const VuoList_VuoAudioSamples value);
/// @}

/**
 * @}
 */

#endif
