/**
 * @file
 * VuoList_VuoImageColorDepth C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoImageColorDepth_H
#define VuoList_VuoImageColorDepth_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoImageColorDepth VuoList_VuoImageColorDepth
 * A list of @ref VuoImageColorDepth elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoImageColorDepth_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoImageColorDepth elements.
 */
typedef void * VuoList_VuoImageColorDepth;
/// @}
#endif

/**
 * Creates a new list of @ref VuoImageColorDepth elements.
 */
VuoList_VuoImageColorDepth VuoListCreate_VuoImageColorDepth(void);

/**
 * Returns the @ref VuoImageColorDepth at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoImageColorDepth VuoListGetValueAtIndex_VuoImageColorDepth(const VuoList_VuoImageColorDepth list, const unsigned long index);

/**
 * Changes the @ref VuoImageColorDepth at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValueAtIndex_VuoImageColorDepth(const VuoList_VuoImageColorDepth list, const VuoImageColorDepth value, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoImageColorDepth(VuoList_VuoImageColorDepth list, const VuoImageColorDepth value);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoImageColorDepth(VuoList_VuoImageColorDepth list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoImageColorDepth(VuoList_VuoImageColorDepth list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoImageColorDepth(VuoList_VuoImageColorDepth list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoImageColorDepth(const VuoList_VuoImageColorDepth list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoImageColorDepth VuoList_VuoImageColorDepth_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoImageColorDepth_jsonFromValue(const VuoList_VuoImageColorDepth value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoImageColorDepth_summaryFromValue(const VuoList_VuoImageColorDepth value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoImageColorDepth VuoList_VuoImageColorDepth_valueFromString(const char *str);
char * VuoList_VuoImageColorDepth_stringFromValue(const VuoList_VuoImageColorDepth value);
/// @}

/**
 * @}
 */

#endif
