/**
 * @file
 * VuoList_VuoImageWrapMode C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoImageWrapMode_H
#define VuoList_VuoImageWrapMode_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoImageWrapMode VuoList_VuoImageWrapMode
 * A list of @ref VuoImageWrapMode elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoImageWrapMode_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoImageWrapMode elements.
 */
typedef void * VuoList_VuoImageWrapMode;
/// @}
#endif

/**
 * Creates a new list of @ref VuoImageWrapMode elements.
 */
VuoList_VuoImageWrapMode VuoListCreate_VuoImageWrapMode(void);

/**
 * Returns the @ref VuoImageWrapMode at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoImageWrapMode VuoListGetValueAtIndex_VuoImageWrapMode(const VuoList_VuoImageWrapMode list, const unsigned long index);

/**
 * Changes the @ref VuoImageWrapMode at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValueAtIndex_VuoImageWrapMode(const VuoList_VuoImageWrapMode list, const VuoImageWrapMode value, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoImageWrapMode(VuoList_VuoImageWrapMode list, const VuoImageWrapMode value);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoImageWrapMode(VuoList_VuoImageWrapMode list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoImageWrapMode(VuoList_VuoImageWrapMode list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoImageWrapMode(VuoList_VuoImageWrapMode list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoImageWrapMode(const VuoList_VuoImageWrapMode list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoImageWrapMode VuoList_VuoImageWrapMode_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoImageWrapMode_jsonFromValue(const VuoList_VuoImageWrapMode value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoImageWrapMode_summaryFromValue(const VuoList_VuoImageWrapMode value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoImageWrapMode VuoList_VuoImageWrapMode_valueFromString(const char *str);
char * VuoList_VuoImageWrapMode_stringFromValue(const VuoList_VuoImageWrapMode value);
/// @}

/**
 * @}
 */

#endif
