/**
 * @file
 * VuoList_VuoLeapHand C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoLeapHand_H
#define VuoList_VuoLeapHand_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoLeapHand VuoList_VuoLeapHand
 * A list of @ref VuoLeapHand elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoLeapHand_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoLeapHand elements.
 */
typedef void * VuoList_VuoLeapHand;
/// @}
#endif

/**
 * Creates a new list of @ref VuoLeapHand elements.
 */
VuoList_VuoLeapHand VuoListCreate_VuoLeapHand(void);

/**
 * Returns the @ref VuoLeapHand at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoLeapHand VuoListGetValueAtIndex_VuoLeapHand(const VuoList_VuoLeapHand list, const unsigned long index);

/**
 * Changes the @ref VuoLeapHand at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValueAtIndex_VuoLeapHand(const VuoList_VuoLeapHand list, const VuoLeapHand value, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoLeapHand(VuoList_VuoLeapHand list, const VuoLeapHand value);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoLeapHand(VuoList_VuoLeapHand list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoLeapHand(VuoList_VuoLeapHand list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoLeapHand(VuoList_VuoLeapHand list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoLeapHand(const VuoList_VuoLeapHand list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoLeapHand VuoList_VuoLeapHand_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoLeapHand_jsonFromValue(const VuoList_VuoLeapHand value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoLeapHand_summaryFromValue(const VuoList_VuoLeapHand value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoLeapHand VuoList_VuoLeapHand_valueFromString(const char *str);
char * VuoList_VuoLeapHand_stringFromValue(const VuoList_VuoLeapHand value);
/// @}

/**
 * @}
 */

#endif
