/**
 * @file
 * VuoList_VuoLeapTouchZone C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoLeapTouchZone_H
#define VuoList_VuoLeapTouchZone_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoLeapTouchZone VuoList_VuoLeapTouchZone
 * A list of @ref VuoLeapTouchZone elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoLeapTouchZone_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoLeapTouchZone elements.
 */
typedef void * VuoList_VuoLeapTouchZone;
/// @}
#endif

/**
 * Creates a new list of @ref VuoLeapTouchZone elements.
 */
VuoList_VuoLeapTouchZone VuoListCreate_VuoLeapTouchZone(void);

/**
 * Returns the @ref VuoLeapTouchZone at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoLeapTouchZone VuoListGetValueAtIndex_VuoLeapTouchZone(const VuoList_VuoLeapTouchZone list, const unsigned long index);

/**
 * Changes the @ref VuoLeapTouchZone at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValueAtIndex_VuoLeapTouchZone(const VuoList_VuoLeapTouchZone list, const VuoLeapTouchZone value, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoLeapTouchZone(VuoList_VuoLeapTouchZone list, const VuoLeapTouchZone value);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoLeapTouchZone(VuoList_VuoLeapTouchZone list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoLeapTouchZone(VuoList_VuoLeapTouchZone list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoLeapTouchZone(VuoList_VuoLeapTouchZone list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoLeapTouchZone(const VuoList_VuoLeapTouchZone list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoLeapTouchZone VuoList_VuoLeapTouchZone_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoLeapTouchZone_jsonFromValue(const VuoList_VuoLeapTouchZone value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoLeapTouchZone_summaryFromValue(const VuoList_VuoLeapTouchZone value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoLeapTouchZone VuoList_VuoLeapTouchZone_valueFromString(const char *str);
char * VuoList_VuoLeapTouchZone_stringFromValue(const VuoList_VuoLeapTouchZone value);
/// @}

/**
 * @}
 */

#endif
