/**
 * @file
 * VuoList_VuoModifierKey C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoModifierKey_H
#define VuoList_VuoModifierKey_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoModifierKey VuoList_VuoModifierKey
 * A list of @ref VuoModifierKey elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoModifierKey_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoModifierKey elements.
 */
typedef void * VuoList_VuoModifierKey;
/// @}
#endif

/**
 * Creates a new list of @ref VuoModifierKey elements.
 */
VuoList_VuoModifierKey VuoListCreate_VuoModifierKey(void);

/**
 * Returns the @ref VuoModifierKey at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoModifierKey VuoListGetValueAtIndex_VuoModifierKey(const VuoList_VuoModifierKey list, const unsigned long index);

/**
 * Changes the @ref VuoModifierKey at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValueAtIndex_VuoModifierKey(const VuoList_VuoModifierKey list, const VuoModifierKey value, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoModifierKey(VuoList_VuoModifierKey list, const VuoModifierKey value);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoModifierKey(VuoList_VuoModifierKey list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoModifierKey(VuoList_VuoModifierKey list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoModifierKey(VuoList_VuoModifierKey list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoModifierKey(const VuoList_VuoModifierKey list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoModifierKey VuoList_VuoModifierKey_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoModifierKey_jsonFromValue(const VuoList_VuoModifierKey value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoModifierKey_summaryFromValue(const VuoList_VuoModifierKey value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoModifierKey VuoList_VuoModifierKey_valueFromString(const char *str);
char * VuoList_VuoModifierKey_stringFromValue(const VuoList_VuoModifierKey value);
/// @}

/**
 * @}
 */

#endif
