/**
 * @file
 * VuoList_VuoRenderedLayers C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoRenderedLayers_H
#define VuoList_VuoRenderedLayers_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoRenderedLayers VuoList_VuoRenderedLayers
 * A list of @ref VuoRenderedLayers elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoRenderedLayers_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoRenderedLayers elements.
 */
typedef void * VuoList_VuoRenderedLayers;
/// @}
#endif

/**
 * Creates a new list of @ref VuoRenderedLayers elements.
 */
VuoList_VuoRenderedLayers VuoListCreate_VuoRenderedLayers(void);

/**
 * Returns the @ref VuoRenderedLayers at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoRenderedLayers VuoListGetValueAtIndex_VuoRenderedLayers(const VuoList_VuoRenderedLayers list, const unsigned long index);

/**
 * Changes the @ref VuoRenderedLayers at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValueAtIndex_VuoRenderedLayers(const VuoList_VuoRenderedLayers list, const VuoRenderedLayers value, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoRenderedLayers(VuoList_VuoRenderedLayers list, const VuoRenderedLayers value);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoRenderedLayers(VuoList_VuoRenderedLayers list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoRenderedLayers(VuoList_VuoRenderedLayers list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoRenderedLayers(VuoList_VuoRenderedLayers list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoRenderedLayers(const VuoList_VuoRenderedLayers list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoRenderedLayers VuoList_VuoRenderedLayers_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoRenderedLayers_jsonFromValue(const VuoList_VuoRenderedLayers value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoRenderedLayers_summaryFromValue(const VuoList_VuoRenderedLayers value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoRenderedLayers VuoList_VuoRenderedLayers_valueFromString(const char *str);
char * VuoList_VuoRenderedLayers_stringFromValue(const VuoList_VuoRenderedLayers value);
/// @}

/**
 * @}
 */

#endif
