/**
 * @file
 * VuoList_VuoSizingMode C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoSizingMode_H
#define VuoList_VuoSizingMode_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoSizingMode VuoList_VuoSizingMode
 * A list of @ref VuoSizingMode elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoSizingMode_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoSizingMode elements.
 */
typedef void * VuoList_VuoSizingMode;
/// @}
#endif

/**
 * Creates a new list of @ref VuoSizingMode elements.
 */
VuoList_VuoSizingMode VuoListCreate_VuoSizingMode(void);

/**
 * Returns the @ref VuoSizingMode at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoSizingMode VuoListGetValueAtIndex_VuoSizingMode(const VuoList_VuoSizingMode list, const unsigned long index);

/**
 * Changes the @ref VuoSizingMode at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValueAtIndex_VuoSizingMode(const VuoList_VuoSizingMode list, const VuoSizingMode value, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoSizingMode(VuoList_VuoSizingMode list, const VuoSizingMode value);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoSizingMode(VuoList_VuoSizingMode list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoSizingMode(VuoList_VuoSizingMode list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoSizingMode(VuoList_VuoSizingMode list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoSizingMode(const VuoList_VuoSizingMode list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoSizingMode VuoList_VuoSizingMode_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoSizingMode_jsonFromValue(const VuoList_VuoSizingMode value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoSizingMode_summaryFromValue(const VuoList_VuoSizingMode value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoSizingMode VuoList_VuoSizingMode_valueFromString(const char *str);
char * VuoList_VuoSizingMode_stringFromValue(const VuoList_VuoSizingMode value);
/// @}

/**
 * @}
 */

#endif
